#include <stdio.h>

#include "libpdf/pdfint.h"
#include "libpdf/pdfobject.h"

PDF_Int PDF_Int_new(int newval)
{
	PDF_Int retval;

	retval = (PDF_Int) PDF_Object_create(sizeof(struct PDF_int), PDF_INT, PDF_CBOOL_FALSE);
	
	if (retval == NULL)
		return NULL;

	retval->value = newval;

	return retval;
}

int PDF_Int_get_value(PDF_Int obj)
{
	return ((PDF_Int) obj)->value;
}

void PDF_Int_set_value(PDF_Int obj, int newval)
{
	((PDF_Int)obj)->value = newval;
}

int PDF_Int_write(PDF_Int obj, FILE *ostream, int index,
				  PDF_CBool put_indirect, PDF_Xref_Table xref,
				  PDF_Queue indqueue)
{
	int numwritten;
	
	numwritten = fprintf(ostream, " %d", PDF_Int_get_value(obj));
	if (numwritten < 0)
		return -1;

	return index+numwritten;
}
