#include <malloc.h>
#include <stdio.h>
#include <string.h>

#include "libpdf/pdfliteral.h"

PDF_Literal PDF_Literal_new(PDF_CString newval)
{
	PDF_Literal retval;
	
	retval = (PDF_Literal) PDF_Object_create(sizeof(struct PDF_literal), PDF_LITERAL, PDF_CBOOL_FALSE);
	if (retval == NULL)
		return NULL;

	
	retval->value = strdup(newval);
	if (retval->value == NULL) {
		free(retval);
		return NULL;
	}

		
	retval->length = strlen(retval->value);

	return retval;
}

PDF_Literal PDF_Literal_connect(void *newval, int length)
{
	PDF_Literal retval;

	retval = (PDF_Literal) PDF_Object_create(sizeof(struct PDF_literal), PDF_LITERAL, PDF_CBOOL_FALSE);
	if (retval == NULL)
		return NULL;

	retval->value = newval;
	retval->length = length;

	return retval;
}

void PDF_Literal_delete(PDF_Literal obj)
{
	free(PDF_Literal_get_value(obj));
}

PDF_CString PDF_Literal_get_value(PDF_Literal obj)
{
	return obj->value;
}

int PDF_Literal_get_length(PDF_Literal obj)
{
	return obj->length;
}
	 
int PDF_Literal_write(PDF_Literal obj, FILE *ostream, int index,
					  PDF_CBool put_indirect, PDF_Xref_Table xref,
					  PDF_Queue indqueue)
{
	int numwritten;
	
	numwritten = fwrite(PDF_Literal_get_value(obj),
						PDF_Literal_get_length(obj),
						1, ostream);
	if (numwritten != 1)
		return -1;
	
	return index + PDF_Literal_get_length(obj);
}
