#ifndef DICTIONARY_H
#define DICTIONARY_H

typedef struct PDF_queue *PDF_Dictionary;
typedef struct PDF_dict_entry *PDF_Dict_Entry;

#include "libpdf/pdfmisc.h"
#include "libpdf/pdfheader.h"
#include "libpdf/pdfobject.h"
#include "libpdf/pdfqueue.h"
#include "libpdf/pdfxref.h"

#include "libpdf/pdfarray.h"
#include "libpdf/pdfbool.h"
#include "libpdf/pdffloat.h"
#include "libpdf/pdfint.h"
#include "libpdf/pdfname.h"
#include "libpdf/pdfstream.h"
#include "libpdf/pdfstring.h"


struct PDF_dict_entry {
	struct PDF_header header;
	PDF_Name key;
	PDF_Object value;
};

PDF_Dict_Entry PDF_Dict_Entry_new(PDF_Name key, PDF_Object value);
void PDF_Dict_Entry_delete(PDF_Dict_Entry entry);
int PDF_Dict_Entry_write(PDF_Dict_Entry entry, FILE *ostream, int index,
						 PDF_CBool put_indirect, PDF_Xref_Table xref,
						 PDF_Queue indqueue);
PDF_Name PDF_Dict_Entry_get_key(PDF_Dict_Entry entry);
PDF_Object PDF_Dict_Entry_get_value(PDF_Dict_Entry entry);
void PDF_Dict_Entry_set_value(PDF_Dict_Entry entry, PDF_Object value);

PDF_Dictionary PDF_Dictionary_new();
PDF_CBool PDF_Dictionary_add_entry(PDF_Dictionary dict, PDF_CString key, PDF_Object value);
PDF_Object PDF_Dictionary_get_entry(PDF_Dictionary dict, PDF_CString key);
int PDF_Dictionary_write(PDF_Dictionary dict, FILE *ostream,
						 int index,
						 PDF_CBool put_indirect, PDF_Xref_Table xref,
						 PDF_Queue indqueue);
#endif
