#ifndef HEADER
#define HEADER

/* Each type of PDF object defined in section 3.2, except no NULL
   object (my guess is that I won't need it; if I do I'll add it).
   The Numeric type (3.2.2) has been broken down into separate integer
   and float types */
typedef enum {PDF_INT, PDF_LITERAL, PDF_QUEUE, PDF_DICT_ENTRY, PDF_STREAM} PDF_ObjType;
typedef struct PDF_header *PDF_Header;

#include "libpdf/pdfmisc.h"

struct PDF_header {
	PDF_ObjType objtype;
	PDF_CBool indirect;
	int objnum;
	int version;
};

void PDF_Header_init(PDF_Header obj, PDF_ObjType objtype, PDF_CBool indirect);

#endif
