#ifndef STREAM_H
#define STREAM_H

typedef struct PDF_stream *PDF_Stream;

#include "libpdf/pdfmisc.h"
#include "libpdf/pdfheader.h"
#include "libpdf/pdfobject.h"

#include "libpdf/pdfarray.h"
#include "libpdf/pdfbool.h"
#include "libpdf/pdfdictionary.h"
#include "libpdf/pdffloat.h"
#include "libpdf/pdfint.h"
/*#include "libpdf/pdfname.h"*/
#include "libpdf/pdfstring.h"
#include "libpdf/pdfxref.h"

struct PDF_stream {
	struct PDF_header header;
	PDF_Dictionary dictionary;
	PDF_Queue content;
};

PDF_Stream PDF_Stream_new();
void PDF_Stream_delete(PDF_Stream stream);
PDF_CBool PDF_Stream_set_param(PDF_Stream stream, PDF_CString paramname, PDF_Object paramval);
PDF_CBool PDF_Stream_append(PDF_Stream stream, PDF_Object newobj);
PDF_Dictionary PDF_Stream_get_dictionary(PDF_Stream stream);
PDF_Queue PDF_Stream_get_content(PDF_Stream stream);
int PDF_Stream_write(PDF_Stream stream, FILE *ostream, int index,
					 PDF_CBool put_indirect, PDF_Xref_Table xref,
					 PDF_Queue indqueue);

#endif
