#ifndef XREF_H
#define XREF_H

#include <stdio.h>

typedef struct PDF_xref *PDF_Xref;
typedef struct PDF_xref_table *PDF_Xref_Table;

#include "libpdf/pdfmisc.h"
#include "libpdf/pdfobject.h"

struct PDF_xref {
	int offset;
	int version;
};

struct PDF_xref_table {
	int maxref;   /* size of table, in xrefs (max useable is maxref-1) */
	int maxused;  /* max obj num used in table */
	PDF_Xref entries; /* array of xref entries */
};

PDF_Xref_Table PDF_Xref_Table_new();
PDF_CBool PDF_Xref_Table_append(PDF_Xref_Table table, int objnum, int offset, int version);
PDF_Xref PDF_Xref_get(PDF_Xref_Table table, int objnum);
int PDF_Xref_Table_new_objnum(PDF_Xref_Table obj);
int PDF_Xref_Table_put(PDF_Xref_Table table, FILE *ostream, int index,
					   PDF_CBool put_indirect,
					   PDF_Xref_Table xref, PDF_Queue indqueue);
#endif
