#include <stdio.h>
#include <math.h>

#include "libpdf/pdfdocument.h"
#include "libpdf/pdfgraphics.h"
#include "libpdf/pdfpath.h"

#define WID 612.0
#define HT 792.0
#define XC (WID/2.0)
#define YC (HT/2.0)
#define RAD (WID/3.0)
#define POINTS 30
#define SKIP 7
#define ANGLE ((2.0*M_PI/(POINTS))*(SKIP))
#define FUZZ .001

main() {
	PDF_Document doc;
	PDF_Page page;
	PDF_Graphics flower;
	
	int numwritten;
	float angle, x, y;

	/* create a document */
	doc = PDF_Document_new(WID, HT);

	/* create a page and add it to the document */
	page = PDF_Page_new(doc);

	/* create a stream and attach it to the page */
	flower = PDF_PageContent_new(page);
	
	/* draw a flower */
	PDF_Path_move(flower, XC + RAD, YC);
	angle = 0;
	do {
		angle += ANGLE;
		if (angle > 2.0*M_PI - FUZZ)
			angle -= 2.0*M_PI;
		
		/*		fprintf(stderr, "%f %f %f %f\n", angle, 2.0*M_PI - FUZZ, XC + RAD*cos(angle), YC + RAD*sin(angle));*/
		
		PDF_Path_line(flower, XC + RAD*cos(angle), YC + RAD*sin(angle));
	} while (angle > FUZZ);
	PDF_Path_paint(flower, PDF_CBOOL_TRUE, PDF_CBOOL_TRUE, PDF_CBOOL_FALSE, PDF_FILL_EVENODD);

	/* put document to standard out */
	numwritten = PDF_Document_write(doc, stdout);

	return 0;
}

	
